import java.io.*;
public class GuuChokiPaa {
	//Método que calcula o saldo das configurações e retorna o inteiro que representa o gesto vencedor
	//0 para Guu, 1 para Paa e 2 para Choki
	public static int vencedor(int contGuu, int contPaa, int contChoki){
		

		int saldoGuu, saldoPaa, saldoChoki;
		/*
		O gesto só poderá ser vencedor caso o número de participantes com aquela configuração seja maior que zero, então
		deve-se verificar isto antes de calcular e estabelecer um valor inválido para o saldo daquela configuração, 
		um valor que torne impossível aquele gesto ser o vencedor.
		*/
		if(contGuu == 0)	saldoGuu = -182;
		else saldoGuu = contChoki - contPaa;	

		if(contPaa == 0) saldoPaa = -182;
		else saldoPaa = contGuu - contChoki;

		if (contChoki == 0) saldoChoki = -182;
		else saldoChoki = contPaa - contGuu;
		//O gesto vencedor será aquele que tiver o maior saldo, lembrando que se ele estiver sozinho, terá o maior saldo.
		if(saldoGuu > saldoPaa && saldoGuu > saldoChoki) return 0;	//Guu ganhou
		if(saldoPaa > saldoGuu && saldoPaa > saldoChoki) return 1;	//Paa ganhou
		if(saldoChoki > saldoGuu && saldoChoki > saldoPaa) return 2; //Choki ganhou
		
		//Este método retorno -1 em caso de empate
		return -1;																//Ninguém venceu (empatou)
	}
	public static void main(String[] args) throws IOException {
		BufferedReader scan = new BufferedReader(new InputStreamReader(System.in));
		String s = scan.readLine();
		while(!s.isEmpty()){
			
			String[] inicio = s.split(" ");
			int n = Integer.parseInt(inicio[0]);
			int m = Integer.parseInt(inicio[1]);
			int[] jogadores = new int[n+1];
			
			int contGuu,contPaa, contChoki;		//Contadores do número de jogadores com cada configuração de mão
			int[] resultado = new int[3];				//Marca o número de rodadas que cada gesto venceu
			
			
			for(int i = 0 ; i < m; i++){
				
				s = scan.readLine();						//Lê uma entrada
				String[] linha = s.split(" ");				//Divide a entrada em um vetor de strings
				contGuu = contPaa = contChoki = 0;	//Inicializa os contadores com 0
				
				int vencedorRodada = -1;					//Inicializa a rodada sem vencedores
				int primeiro = Integer.parseInt(linha[1]);
				int ultimo = Integer.parseInt(linha[2]);
				
				//Se o comando for C, o programa faz a contagem do número de jogadores 
				//com cada configuração de mão no intervalo especificado e imprime na ordem solicitada no enunciado
				if(linha[0].equals("C")){
					for(int j = primeiro; j <= ultimo; j++){
						if(jogadores[j] == 0) contGuu++;
						else if(jogadores[j] == 1) contPaa++;
						else contChoki++;
					}
					
					System.out.println("Guu: " + contGuu + ", Choki: " + contChoki + " e Paa: " + contPaa + ".");
				
				} else {
					//Se o comando for M, o programa modifica as configurações dos jogadores no intervalo especificado
					for(int j = primeiro; j <= ultimo; j++){
						jogadores[j] = (jogadores[j]+1)%3;
					}
					
					//Este laço faz a contagem do total de cada gesto na rodada para determinar o vencedor
					for(int j = 1; j < jogadores.length; j++){
						if(jogadores[j] == 0) contGuu++;
						else if(jogadores[j] == 1) contPaa++;
						else contChoki++;
					}
					
					//Armazena o vencedor da rodada (0: Guu, 1: Paa, 2: Choki e -1 para empate) 
					vencedorRodada = vencedor(contGuu, contPaa, contChoki);
					
					//Caso não seja empate, incrementa o vencedor da rodada no resultado final
					if(vencedorRodada != -1){
						
						resultado[vencedorRodada]++;
						
						//Imprime o vencedor da rodada
						if(vencedorRodada == 0){
							System.out.println("Guu venceu a rodada.");
						}else if (vencedorRodada == 1){
							System.out.println("Paa venceu a rodada.");
						}else{
							System.out.println("Choki venceu a rodada.");
						}
					}else System.out.println("A rodada terminou empatada.");
					
				}
			}
			
			
			//Imprime o resultado do campeonato. O gesto que tiver o maior número de rodadas ganhas será o gesto vencedor
			//Caso o haja empate entre dois ou mais gestos, não haverá vencedores, conforme enunciado
			if(resultado[0] > resultado[1] && resultado[0] > resultado[2])	System.out.println("Guu venceu o torneio.");				
			else if(resultado[1] > resultado[0] && resultado[1] > resultado[2]) System.out.println("Paa venceu o torneio.");		
			else if(resultado[2] > resultado[0] && resultado[2] > resultado[1]) System.out.println("Choki venceu o torneio.");
			else System.out.println("O torneio terminou sem vencedores.");
			
			//Imprime uma quebra de linha entre os casos de teste
			System.out.println();
			s = scan.readLine();
		}
		
	}

}
